/* Some fragments designed to look at how the code comes out.

   Copyright 2007 Kevin Ryde

   This file is part of Redc1.

   Redc1 is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.

   Redc1 is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with Redc1; see the file COPYING.  If not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
   USA.  */

#include <stdio.h>
#include <stdlib.h>
#include "redc1.h"


mp_limb_t N, Ninv, RmodN, R2modN;

mp_limb_t
addmod (mp_limb_t x, mp_limb_t y)
{
  mp_limb_t z;
  addmod_saam (z, x, y, N);
  return z;
}

mp_limb_t
submod (mp_limb_t x, mp_limb_t y)
{
  mp_limb_t z;
  submod_dmsm (z, x, y, N);
  return z;
}

mp_limb_t
redc_mul (mp_limb_t x, mp_limb_t y)
{
  mp_limb_t z;
  REDC1_MUL (z, x, y, N, Ninv);
  return z;
}

mp_limb_t
preinv_mul (mp_limb_t x, mp_limb_t y)
{
  mp_limb_t h, l, z, dummy;
  umul_ppmm (h,l, x, y);
  udiv_qrnnd_preinv (dummy, z, h,l, N,Ninv);
  return z;
}
